﻿Public Class ChildForm2

    ' 부모 폼과 관련된 라디오 버튼 값을 저장하는 변수
    Private m_piSetMainRadioSub2 As Integer
    ' 외부에서 자식 폼2의 값을 접근하기 위한 속성
    Public Property piSetMainRadioSub2() As Integer
        Get
            ' Getter 시 접근
            Return m_piSetMainRadioSub2
        End Get
        Set(ByVal value As Integer)
            ' Setter 시 접근
            m_piSetMainRadioSub2 = value
            ' 전달받은 값에 따라 UI를 변경
            Select Case m_piSetMainRadioSub2
                Case 0
                    radParent0.Checked = True
                Case 1
                    radParent1.Checked = True
                Case 2
                    radParent2.Checked = True
                Case 3
                    radParent3.Checked = True
                Case Else
            End Select
        End Set
    End Property

    ' 자식 폼과 관련된 라디오 버튼 값을 저장하는 변수
    Private m_piSetChildRadioSub2 As Integer
    ' 외부에서 자식 폼2의 값을 접근하기 위한 속성
    Public Property piSetChildRadioSub2() As Integer
        Get
            ' Getter 시 접근
            Return m_piSetChildRadioSub2
        End Get
        Set(ByVal value As Integer)
            ' Setter 시 접근
            m_piSetChildRadioSub2 = value

            Select Case m_piSetChildRadioSub2
                Case 0
                    radChild0.Checked = True
                Case 1
                    radChild1.Checked = True
                Case 2
                    radChild2.Checked = True
                Case 3
                    radChild3.Checked = True
                Case Else
            End Select
        End Set
    End Property

    ' 부모 폼으로부터 자식 폼2을 전달받기 위한 변수와 속성. (쓰기전용)
    Private m_pfrmSub1 As ChildForm1

    Public WriteOnly Property pfrmSub1() As ChildForm1
        Set(ByVal value As ChildForm1)
            m_pfrmSub1 = value
        End Set
    End Property

    Private Sub ChildForm2_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        radParent0.TabIndex = 0
        radParent1.TabIndex = 1
        radParent2.TabIndex = 2
        radParent3.TabIndex = 3
        radChild0.TabIndex = 0
        radChild1.TabIndex = 1
        radChild2.TabIndex = 2
        radChild3.TabIndex = 3
    End Sub

    ' Form 이동을 위한 Click 이벤트
    Private Sub ChangeFormButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnMainForm.Click, btnChildForm1.Click
        If sender Is btnMainForm Then
            SmartForm1.Show(0)
        Else
            SmartForm1.Show(1)
        End If
    End Sub

    ' 부모 폼 UI 변경 라디오 버튼 클릭 시 발생하는 이벤트
    Private Sub Radio_Child_to_Main(ByVal sender As Object, ByVal e As EventArgs) Handles radParent3.Click, radParent2.Click, radParent1.Click, radParent0.Click
        ' 클릭한 라디오 버튼에 따라 값을 설정
        m_piSetMainRadioSub2 = (CType(sender, SmartX.SmartRadioButton)).TabIndex

        ' Owner 속성으로 부모 폼을 참조하여 값을 전달. (Setter)
        DirectCast((Owner), MainForm).piSetMainRadio = m_piSetMainRadioSub2
        DirectCast((Owner), MainForm).piSetMainRadioSub1 = m_piSetMainRadioSub2
    End Sub

    ' 자식 폼1 UI 변경 라디오 버튼 클릭 시 발생하는 이벤트
    Private Sub Radio_Child_to_Child(ByVal sender As Object, ByVal e As EventArgs) Handles radChild3.Click, radChild2.Click, radChild1.Click, radChild0.Click
        ' 클릭한 라디오 버튼에 따라 값을 설정
        m_piSetChildRadioSub2 = (CType(sender, SmartX.SmartRadioButton)).TabIndex

        ' Owner 속성으로 부모 폼을 경유하여 자식 폼1로 값을 전달. (Setter)
        DirectCast((Owner), MainForm).piSetChild1Radio = m_piSetChildRadioSub2
    End Sub

    ' 부모 폼 UI 값 Getter 클릭 시 발생하는 이벤트
    Private Sub btnGetter1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnGetter1.Click
        ' Owner 속성으로 부모 폼을 참조하여 값을 가져옴. (Getter)
        m_piSetMainRadioSub2 = (CType((Owner), MainForm)).piSetMainRadio
        ' 전달받은 값에 따라 라벨에 값 출력
        Select Case m_piSetMainRadioSub2
            Case 0
                labGetValue1.Text = "Main_radio0"
            Case 1
                labGetValue1.Text = "Main_radio1"
            Case 2
                labGetValue1.Text = "Main_radio2"
            Case 3
                labGetValue1.Text = "Main_radio3"
            Case Else
        End Select
    End Sub

    ' 자식 폼1 UI 값 Getter 클릭 시 발생하는 이벤트
    Private Sub btnGetter2_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnGetter2.Click
        ' Owner 속성으로 부모 폼을 경유하여 자식 폼1의 값을 가져옴. (Getter)
        m_piSetChildRadioSub2 = (CType((Owner), MainForm)).piSetChild1Radio
        ' 전달받은 값에 따라 라벨에 값 출력
        Select Case m_piSetChildRadioSub2
            Case 0
                labGetValue2.Text = "Child1_radio0"
            Case 1
                labGetValue2.Text = "Child1_radio1"
            Case 2
                labGetValue2.Text = "Child1_radio2"
            Case 3
                labGetValue2.Text = "Child1_radio3"
            Case Else
        End Select
    End Sub
End Class